/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;

import org.json.JSONObject;
/**
 * 抽象类Node，表示一个任务节点。
 */
public abstract class Node {
    // 同步操作类型常量定义
    public static final int SYNC_ACTION_NONE = 0;
    public static final int SYNC_ACTION_ADD_REMOTE = 1;
    public static final int SYNC_ACTION_ADD_LOCAL = 2;
    public static final int SYNC_ACTION_DEL_REMOTE = 3;
    public static final int SYNC_ACTION_DEL_LOCAL = 4;
    public static final int SYNC_ACTION_UPDATE_REMOTE = 5;
    public static final int SYNC_ACTION_UPDATE_LOCAL = 6;
    public static final int SYNC_ACTION_UPDATE_CONFLICT = 7;
    public static final int SYNC_ACTION_ERROR = 8;

    private String mGid;  // 任务节点的唯一标识
    private String mName;  // 任务节点的名称
    private long mLastModified;  // 任务节点的最后修改时间
    private boolean mDeleted;  // 标识任务节点是否被删除

    /**
     * 构造方法Node，初始化成员变量。
     */
    public Node() {
        mGid = null;  // 初始化为null
        mName = "";  // 初始化为空字符串
        mLastModified = 0;  // 初始化为0
        mDeleted = false;  // 初始化为false
    }

    /**
     * 抽象方法getCreateAction，接受一个整型参数actionId，返回一个JSONObject对象，表示创建节点操作。
     */
    public abstract JSONObject getCreateAction(int actionId);

    /**
     * 抽象方法getUpdateAction，接受一个整型参数actionId，返回一个JSONObject对象，表示更新节点操作。
     */
    public abstract JSONObject getUpdateAction(int actionId);

    /**
     * 抽象方法setContentByRemoteJSON，接受一个JSONObject类型的参数js，根据远端传来的信息设置节点内容。
     */
    public abstract void setContentByRemoteJSON(JSONObject js);

    /**
     * 抽象方法setContentByLocalJSON，接受一个JSONObject类型的参数js，根据本地传来的信息设置节点内容。
     */
    public abstract void setContentByLocalJSON(JSONObject js);

    /**
     * 抽象方法getLocalJSONFromContent，返回一个JSONObject对象，表示本地节点的内容。
     */
    public abstract JSONObject getLocalJSONFromContent();

    /**
     * 抽象方法getSyncAction，接受一个Cursor类型的参数c，返回一个整型值，表示同步操作。
     */
    public abstract int getSyncAction(Cursor c);

    /**
     * setGid方法，接受一个字符串参数gid，设置节点的Gid。
     */
    public void setGid(String gid) {
        this.mGid = gid;
    }

    /**
     * setName方法，接受一个字符串参数name，设置节点的名称。
     */
    public void setName(String name) {
        this.mName = name;
    }

    /**
     * setLastModified方法，接受一个长整型参数lastModified，设置节点的最后修改时间。
     */
    public void setLastModified(long lastModified) {
        this.mLastModified = lastModified;
    }

    /**
     * setDeleted方法，接受一个布尔型参数deleted，设置节点是否被删除。
     */
    public void setDeleted(boolean deleted) {
        this.mDeleted = deleted;
    }

    /**
     * getGid方法，返回节点的Gid。
     */
    public String getGid() {
        return this.mGid;
    }

    /**
     * getName方法，返回节点的名称。
     */
    public String getName() {
        return this.mName;
    }

    /**
     * getLastModified方法，返回节点的最后修改时间。
     */
    public long getLastModified() {
        return this.mLastModified;
    }

    /**
     * getDeleted方法，返回节点是否被删除。
     */
    public boolean getDeleted() {
        return this.mDeleted;
    }

}
